-rwxr-xr-x | scripts/ipkg-build | 194 | ||||
-rwxr-xr-x | scripts/ipkg-unbuild | 29 |
2 files changed, 223 insertions, 0 deletions
diff --git a/scripts/ipkg-build b/scripts/ipkg-build new file mode 100755 index 0000000..ac8f286 --- a/dev/null +++ b/scripts/ipkg-build | |||
@@ -0,0 +1,194 @@ | |||
1 | #!/bin/bash | ||
2 | |||
3 | # ipkg-build -- construct a .ipk from a directory | ||
4 | # Carl Worth <cworth@east.isi.edu> | ||
5 | # based on a script by Steve Redler IV, steve@sr-tech.com 5-21-2001 | ||
6 | set -e | ||
7 | |||
8 | ipkg_extract_value() { | ||
9 | sed -e "s/^[^:]*:[[:space:]]*//" | ||
10 | } | ||
11 | |||
12 | required_field() { | ||
13 | field=$1 | ||
14 | |||
15 | value=`grep "^$field:" < $CONTROL/control | ipkg_extract_value` | ||
16 | if [ -z "$value" ]; then | ||
17 | echo "*** Error: $CONTROL/control is missing field $field" >&2 | ||
18 | return 1 | ||
19 | fi | ||
20 | echo $value | ||
21 | return 0 | ||
22 | } | ||
23 | |||
24 | pkg_appears_sane() { | ||
25 | local pkg_dir=$1 | ||
26 | |||
27 | local owd=`pwd` | ||
28 | cd $pkg_dir | ||
29 | |||
30 | PKG_ERROR=0 | ||
31 | |||
32 | tilde_files=`find . -name '*~'` | ||
33 | if [ -n "$tilde_files" ]; then | ||
34 | echo "*** Warning: The following files have names ending in '~'. | ||
35 | You probably want to remove them: " >&2 | ||
36 | ls -ld $tilde_files | ||
37 | echo >&2 | ||
38 | fi | ||
39 | |||
40 | large_uid_files=`find . -uid +99` | ||
41 | |||
42 | if [ "$ogargs" = "" ] && [ -n "$large_uid_files" ]; then | ||
43 | echo "*** Warning: The following files have a UID greater than 99. | ||
44 | You probably want to chown these to a system user: " >&2 | ||
45 | ls -ld $large_uid_files | ||
46 | echo >&2 | ||
47 | fi | ||
48 | |||
49 | |||
50 | if [ ! -f "$CONTROL/control" ]; then | ||
51 | echo "*** Error: Control file $pkg_dir/$CONTROL/control not found." >&2 | ||
52 | cd $owd | ||
53 | return 1 | ||
54 | fi | ||
55 | |||
56 | pkg=`required_field Package` | ||
57 | [ "$?" -ne 0 ] && PKG_ERROR=1 | ||
58 | |||
59 | version=`required_field Version | sed 's/.*://;'` | ||
60 | [ "$?" -ne 0 ] && PKG_ERROR=1 | ||
61 | |||
62 | arch=`required_field Architecture` | ||
63 | [ "$?" -ne 0 ] && PKG_ERROR=1 | ||
64 | |||
65 | required_field Maintainer >/dev/null | ||
66 | [ "$?" -ne 0 ] && PKG_ERROR=1 | ||
67 | |||
68 | required_field Description >/dev/null | ||
69 | [ "$?" -ne 0 ] && PKG_ERROR=1 | ||
70 | |||
71 | section=`required_field Section` | ||
72 | [ "$?" -ne 0 ] && PKG_ERROR=1 | ||
73 | if [ -z "$section" ]; then | ||
74 | echo "The Section field should have one of the following values:" >&2 | ||
75 | echo "admin, base, comm, editors, extras, games, graphics, kernel, libs, misc, net, text, web, x11" >&2 | ||
76 | fi | ||
77 | |||
78 | priority=`required_field Priority` | ||
79 | [ "$?" -ne 0 ] && PKG_ERROR=1 | ||
80 | if [ -z "$priority" ]; then | ||
81 | echo "The Priority field should have one of the following values:" >&2 | ||
82 | echo "required, important, standard, optional, extra." >&2 | ||
83 | echo "If you don't know which priority value you should be using, then use \`optional'" >&2 | ||
84 | fi | ||
85 | |||
86 | if echo $pkg | grep '[^a-z0-9.+-]'; then | ||
87 | echo "*** Error: Package name $name contains illegal characters, (other than [a-z0-9.+-])" >&2 | ||
88 | PKG_ERROR=1; | ||
89 | fi | ||
90 | |||
91 | local bad_fields=`sed -ne 's/^\([^[:space:]][^:[:space:]]\+[[:space:]]\+\)[^:].*/\1/p' < $CONTROL/control | sed -e 's/\\n//'` | ||
92 | if [ -n "$bad_fields" ]; then | ||
93 | bad_fields=`echo $bad_fields` | ||
94 | echo "*** Error: The following fields in $CONTROL/control are missing a ':'" >&2 | ||
95 | echo "$bad_fields" >&2 | ||
96 | echo "ipkg-build: This may be due to a missing initial space for a multi-line field value" >&2 | ||
97 | PKG_ERROR=1 | ||
98 | fi | ||
99 | |||
100 | for script in $CONTROL/preinst $CONTROL/postinst $CONTROL/prerm $CONTROL/postrm; do | ||
101 | if [ -f $script -a ! -x $script ]; then | ||
102 | echo "*** Error: package script $script is not executable" >&2 | ||
103 | PKG_ERROR=1 | ||
104 | fi | ||
105 | done | ||
106 | |||
107 | if [ -f $CONTROL/conffiles ]; then | ||
108 | for cf in `cat $CONTROL/conffiles`; do | ||
109 | if [ ! -f ./$cf ]; then | ||
110 | echo "*** Error: $CONTROL/conffiles mentions conffile $cf which does not exist" >&2 | ||
111 | PKG_ERROR=1 | ||
112 | fi | ||
113 | done | ||
114 | fi | ||
115 | |||
116 | cd $owd | ||
117 | return $PKG_ERROR | ||
118 | } | ||
119 | |||
120 | ### | ||
121 | # ipkg-build "main" | ||
122 | ### | ||
123 | ogargs="" | ||
124 | usage="Usage: $0 [-o owner] [-g group] <pkg_directory> [<destination_directory>]" | ||
125 | while getopts ":o:g:" opt; do | ||
126 | case $opt in | ||
127 | o ) owner=$OPTARG | ||
128 | ogargs="--owner=$owner" | ||
129 | ;; | ||
130 | g ) group=$OPTARG | ||
131 | ogargs="$ogargs --group=$group" | ||
132 | ;; | ||
133 | \? ) echo $usage >&2 | ||
134 | esac | ||
135 | done | ||
136 | |||
137 | |||
138 | shift $(($OPTIND - 1)) | ||
139 | |||
140 | # continue on to process additional arguments | ||
141 | |||
142 | case $# in | ||
143 | 1) | ||
144 | dest_dir=. | ||
145 | ;; | ||
146 | 2) | ||
147 | dest_dir=$2 | ||
148 | ;; | ||
149 | *) | ||
150 | echo echo $usage >&2 | ||
151 | exit 1 | ||
152 | ;; | ||
153 | esac | ||
154 | |||
155 | pkg_dir=$1 | ||
156 | |||
157 | if [ ! -d $pkg_dir ]; then | ||
158 | echo "*** Error: Directory $pkg_dir does not exist" >&2 | ||
159 | exit 1 | ||
160 | fi | ||
161 | |||
162 | # CONTROL is second so that it takes precedence | ||
163 | CONTROL= | ||
164 | [ -d $pkg_dir/DEBIAN ] && CONTROL=DEBIAN | ||
165 | [ -d $pkg_dir/CONTROL ] && CONTROL=CONTROL | ||
166 | if [ -z "$CONTROL" ]; then | ||
167 | echo "*** Error: Directory $pkg_dir has no CONTROL subdirectory." >&2 | ||
168 | exit 1 | ||
169 | fi | ||
170 | |||
171 | if ! pkg_appears_sane $pkg_dir; then | ||
172 | echo >&2 | ||
173 | echo "ipkg-build: Please fix the above errors and try again." >&2 | ||
174 | exit 1 | ||
175 | fi | ||
176 | |||
177 | tmp_dir=$dest_dir/IPKG_BUILD.$$ | ||
178 | mkdir $tmp_dir | ||
179 | |||
180 | tar $ogargs -C $pkg_dir -czf $tmp_dir/data.tar.gz . --exclude=$CONTROL | ||
181 | tar $ogargs -C $pkg_dir/$CONTROL -czf $tmp_dir/control.tar.gz . | ||
182 | |||
183 | echo "2.0" > $tmp_dir/debian-binary | ||
184 | |||
185 | pkg_file=$dest_dir/${pkg}_${version}_${arch}.ipk | ||
186 | here_dir=$PWD | ||
187 | ## tar -C $tmp_dir -czf $pkg_file ./debian-binary ./data.tar.gz ./control.tar.gz | ||
188 | rm -f $pkg_file | ||
189 | cd $tmp_dir ; ar crf $here_dir/$pkg_file ./debian-binary ./data.tar.gz ./control.tar.gz | ||
190 | cd $here_dir | ||
191 | rm $tmp_dir/debian-binary $tmp_dir/data.tar.gz $tmp_dir/control.tar.gz | ||
192 | rmdir $tmp_dir | ||
193 | |||
194 | echo "Packaged contents of $pkg_dir into $pkg_file" | ||
diff --git a/scripts/ipkg-unbuild b/scripts/ipkg-unbuild new file mode 100755 index 0000000..f724f75 --- a/dev/null +++ b/scripts/ipkg-unbuild | |||
@@ -0,0 +1,29 @@ | |||
1 | #!/bin/sh | ||
2 | |||
3 | set -e | ||
4 | |||
5 | if [ $# -lt 1 ]; then | ||
6 | echo "usage: $0: package.ipk" | ||
7 | exit 1 | ||
8 | fi | ||
9 | |||
10 | while [ $# -gt 0 ]; do | ||
11 | filename=$1 | ||
12 | shift | ||
13 | |||
14 | pkg=`echo $filename | sed 's/.*\///;s/.ipk$//;s/.deb$//'` | ||
15 | |||
16 | mkdir -p $pkg | ||
17 | mkdir -p $pkg/CONTROL | ||
18 | |||
19 | pkg_dir=$PWD | ||
20 | cd $pkg; (ar x ../$filename || tar zxf ../$filename) >& /dev/null | ||
21 | cd $pkg_dir | ||
22 | |||
23 | tar xzf $pkg/data.tar.gz -C $pkg | ||
24 | tar xzf $pkg/control.tar.gz -C $pkg/CONTROL | ||
25 | rm -f $pkg/control.tar.gz $pkg/data.tar.gz $pkg/debian-binary | ||
26 | done | ||
27 | |||
28 | |||
29 | |||